﻿# 自动检测第一个容器中 TxBugReport.exe 与 WXWorkWeb.exe 的位置 
# 使用桌面上的 Sleep10.exe 替换容器中的以上文件 


# 替换窗口中的 TxBugReport
$ErrorActionPreference = 'Stop'

# 要规则多少个窗口中的文件 ,   也可以使用 Get-Date (docker inspect c4e79a87bd4f | ConvertFrom-Json ).State.StartedAt 获取真实的启动时间再进行处理
# 0 为全部
$replaceCount = 0 

$fileNames = @()
$fileNames += 'TxBugReport.exe'
$fileNames += 'WXWorkWeb.exe'


# 获取待处理文件 
$dockerId = docker ps -q -n 1
echo "测试 id : $dockerId"

$filePaths = @()

foreach ($fileName in $fileNames)
{
	$txt = docker exec $dockerId powershell -Command "Get-ChildItem $fileName -Path c:\gnlab\wxwork -Recurse | Select-Object FullName | Format-Table -HideTableHeaders -Wrap"
	$files = $txt | %  { $_.trim() } | ? { $_.Length -gt 0 }
	
	$filePaths += $files
}

echo "共有文件 $($filePaths.Length) 个"
$filePaths | % { echo $_ }


# 获取待处理容器
$pscmd = "docker ps -q "
if ($replaceCount -gt 0)
{
	$pscmd += " -n $replaceCount "
}

$dockerIds = Invoke-Expression $pscmd
echo "共有待处理容器 $($dockerIds.Length) 个"


# 开始替换文件 
$desktop = [system.Environment]::GetFolderPath('Desktop')
$sleepPath = Join-Path $desktop -ChildPath 'Sleep10.exe'

if (-not [System.IO.File]::Exists($sleepPath))
{
	throw [System.IO.FileNotFoundException]::new('请在桌面上准备 sleep10.exe 文件 ')
}

$length = $dockerIds.Length

foreach ($dockerId in $dockerIds)
{
	$length -= 1
	echo "$dockerId $($length)/$($dockerIds.Length)"
	
	foreach ($filePath in $filePaths)
	{
		docker cp $sleepPath "$($dockerId):$($filePath)"
	}
}
